%bcond_without  jp_minimal

Summary:        Java logging package
Name:           log4j
Version:        2.17.2
Release:        2%{?dist}
License:        ASL 2.0
URL:            https://logging.apache.org/%{name}
Source0:        https://archive.apache.org/dist/logging/log4j/%{version}/apache-log4j-%{version}-src.tar.gz

Patch3000:         logging-log4j-Remove-unsupported-EventDataConverter.patch

BuildRequires: mvn(org.jctools:jctools-core) mvn(org.osgi:osgi.core) mvn(org.slf4j:slf4j-api)
BuildRequires: mvn(org.apache.maven.plugins:maven-assembly-plugin) mvn(org.apache.maven.plugins:maven-dependency-plugin) mvn(org.codehaus.mojo:build-helper-maven-plugin) mvn(org.fusesource.jansi:jansi)
BuildRequires: mvn(commons-logging:commons-logging) mvn(javax.servlet:javax.servlet-api) mvn(org.apache.commons:commons-compress) mvn(org.apache.felix:maven-bundle-plugin)
BuildRequires: maven-local mvn(com.lmax:disruptor) mvn(com.sun.activation:jakarta.activation) mvn(com.sun.mail:javax.mail)

%if %{without jp_minimal}
BuildRequires: mvn(org.zeromq:jeromq) mvn(sun.jdk:jconsole)
BuildRequires: mvn(org.lightcouch:lightcouch) mvn(org.osgi:osgi.core) mvn(org.slf4j:slf4j-api) mvn(org.slf4j:slf4j-ext)
BuildRequires: mvn(org.eclipse.persistence:javax.persistence) mvn(org.fusesource.jansi:jansi:1) mvn(org.jboss.spec.javax.jms:jboss-jms-api_1.1_spec) mvn(org.jctools:jctools-core)
BuildRequires: mvn(org.apache.logging:logging-parent:pom:) mvn(org.apache.tomcat:tomcat-catalina) mvn(org.codehaus.mojo:build-helper-maven-plugin) mvn(org.eclipse.jetty:jetty-util)
BuildRequires: mvn(com.sun.mail:javax.mail) mvn(jakarta.servlet:jakarta.servlet-api) mvn(javax.servlet.jsp:jsp-api) mvn(org.apache.commons:commons-csv)
BuildRequires: mvn(com.fasterxml.jackson.dataformat:jackson-dataformat-xml) mvn(com.fasterxml.jackson.dataformat:jackson-dataformat-yaml) mvn(com.fasterxml.woodstox:woodstox-core) mvn(com.lmax:disruptor)
BuildRequires: mvn(com.datastax.cassandra:cassandra-driver-core) mvn(com.fasterxml.jackson.core:jackson-annotations) mvn(com.fasterxml.jackson.core:jackson-core) mvn(com.fasterxml.jackson.core:jackson-databind)
Requires:       javapackages-tools
%endif

BuildArch:      noarch
ExclusiveArch:  %{java_arches} noarch

%description
Apache Log4j 2 is an upgrade to Log4j that provides significant
improvements over its predecessor, Log4j 1.x, and provides many
of the improvements available in Logback while fixing some inherent
problems in Logback's architecture.

%package slf4j
Summary:        Binding between LOG4J 2 API and SLF4J

%description slf4j
Binding between LOG4J 2 API and SLF4J.

%package jcl
Summary:        Apache Log4j Commons Logging Bridge

%description jcl
Apache Log4j Commons Logging Bridge.

%package web
Summary:        Apache Log4j Web

%description web
Support for Log4j in a web servlet container.

%if %{without jp_minimal}
%package osgi
Summary:        Apache Log4J Core OSGi Bundles

%description osgi
Apache Log4J Core OSGi Bundles.

%package taglib
Summary:        Apache Log4j Tag Library

%description taglib
Apache Log4j Tag Library for Web Applications.

%package jmx-gui
Summary:        Apache Log4j JMX GUI
Requires:       java-devel

%description jmx-gui
Swing-based client for remotely editing the log4j configuration and remotely
monitoring StatusLogger output. Includes a JConsole plug-in.

%package bom
Summary:        Apache Log4j BOM

%description bom
Apache Log4j 2 Bill of Material


%package nosql
Summary:        Apache Log4j NoSql

%description nosql
Use NoSQL databases such as MongoDB and CouchDB to append log messages.

%endif

%package        javadoc
Summary:        API documentation for %{name}

%description    javadoc
%{summary}.

%prep
%autosetup -n apache-%{name}-%{version}-src -N

find -name '*.jar' -delete
find -name '*.class' -delete
find -name '*.zip' -delete
find -name '*.dll' -delete
rm -rf src/site

%patch3000 -p1

%pom_remove_plugin -r :maven-site-plugin
%pom_remove_plugin -r :maven-remote-resources-plugin
%pom_remove_plugin -r :maven-doap-plugin
%pom_remove_plugin -r :maven-source-plugin
%pom_remove_plugin -r :maven-toolchains-plugin
%pom_remove_plugin -r :revapi-maven-plugin

find -name "*.jar" -o -name "*.class" -delete
rm -rf docs/api

%pom_disable_module %{name}-distribution
%pom_disable_module %{name}-samples

%pom_disable_module %{name}-flume-ng

%pom_disable_module %{name}-perf

%pom_add_dep com.sun.activation:jakarta.activation

rm log4j-core/src/main/java/org/apache/logging/log4j/core/async/DisruptorBlockingQueueFactory.java
%pom_remove_dep -r com.conversantmedia:disruptor

rm -r log4j-core/src/main/java/org/apache/logging/log4j/core/appender/mom/kafka
%pom_remove_dep -r :kafka-clients

%pom_disable_module %{name}-liquibase
%pom_disable_module %{name}-slf4j18-impl
%pom_disable_module %{name}-jdbc-dbcp2
%pom_disable_module %{name}-mongodb3
%pom_disable_module %{name}-mongodb4
%pom_remove_dep :jconsole %{name}-jmx-gui
%pom_add_dep sun.jdk:jconsole %{name}-jmx-gui
%pom_change_dep -r org.osgi:org.osgi.core org.osgi:osgi.core
%pom_remove_plugin :apache-rat-plugin %{name}-bom
%pom_remove_plugin :maven-failsafe-plugin
%pom_remove_dep -r :slf4j-ext
%pom_remove_parent
%pom_xpath_inject 'pom:plugin[pom:artifactId="maven-compiler-plugin"]/pom:configuration' "<release>8</release>"

%if %{with jp_minimal}
%pom_disable_module %{name}-taglib
%pom_disable_module %{name}-jmx-gui
%pom_disable_module %{name}-bom
%pom_disable_module %{name}-jakarta-web
%pom_disable_module %{name}-iostreams
%pom_disable_module %{name}-jul
%pom_disable_module %{name}-core-its
%pom_disable_module %{name}-jpa
%pom_disable_module %{name}-couchdb
%pom_disable_module %{name}-cassandra
%pom_disable_module %{name}-appserver
%pom_disable_module %{name}-spring-cloud-config
%pom_disable_module %{name}-spring-boot
%pom_disable_module %{name}-docker
%pom_disable_module %{name}-kubernetes
%pom_disable_module %{name}-layout-template-json

%pom_remove_dep -r :jackson-annotations
%pom_remove_dep -r :jackson-core
%pom_remove_dep -r :jackson-databind
%pom_remove_dep -r :jackson-dataformat-yaml
%pom_remove_dep -r :jackson-dataformat-xml
%pom_remove_dep -r :woodstox-core
%pom_remove_dep -r :javax.persistence
%pom_remove_dep -r :jboss-jms-api_1.1_spec
%pom_remove_dep -r :jeromq
%pom_remove_dep -r :commons-csv

rm -r log4j-core/src/main/java/org/apache/logging/log4j/core/{jackson,config/yaml,config/json,parser}
rm -r log4j-core/src/main/java/org/apache/logging/log4j/core/appender/{db,mom,nosql}
rm log4j-core/src/main/java/org/apache/logging/log4j/core/layout/*{Csv,Jackson,Xml,Yaml,Json,Gelf}*.java
rm log4j-1.2-api/src/main/java/org/apache/log4j/builders/layout/*Xml*.java
rm log4j-api/src/main/java/org/apache/logging/log4j/util/Activator.java
rm -r log4j-1.2-api/src/main/java/org/apache/log4j/or/jms
%endif

%mvn_alias :%{name}-1.2-api %{name}:%{name}
%mvn_file ':{%{name}-1.2-api}' %{name}/@1 %{name}

%mvn_package ':%{name}-slf4j-impl' slf4j
%mvn_package ':%{name}-to-slf4j' slf4j
%mvn_package ':%{name}-taglib' taglib
%mvn_package ':%{name}-jcl' jcl
%mvn_package ':%{name}-jmx-gui' jmx-gui
%mvn_package ':%{name}-web' web
%mvn_package ':%{name}-bom' bom
%mvn_package ':%{name}-cassandra' nosql
%mvn_package ':%{name}-couchdb' nosql
%mvn_package :log4j-core-its __noinstall

%build
%mvn_build -f -j

%install
%mvn_install

%if %{without jp_minimal}
%jpackage_script org.apache.logging.log4j.jmx.gui.ClientGUI '' '' %{name}/%{name}-jmx-gui:%{name}/%{name}-core %{name}-jmx false
%endif

%files -f .mfiles
%doc LICENSE.txt NOTICE.txt

%files slf4j -f .mfiles-slf4j

%files jcl -f .mfiles-jcl

%files web -f .mfiles-web

%if %{without jp_minimal}
%files taglib -f .mfiles-taglib

%files bom -f .mfiles-bom

%files nosql -f .mfiles-nosql

%files jmx-gui -f .mfiles-jmx-gui
%{_bindir}/%{name}-jmx
%endif

%changelog
* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.17.2-2
- Rebuilt for OpenCloudOS Stream 23.05

* Wed Apr 26 2023 cunshunxia <cunshunxia@tencent.com> - 2.17.2-1
- initial build
